﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using System.Collections.ObjectModel;
using System.ComponentModel;

namespace SelectedItemBinding
{
    public class SampleViewModel : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged = null;

        protected virtual void NotifyPropertyChanged(string propertyname)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyname));
            }
        }

        public Country SelectedItem
        {
            get;
            set;
        }

        public Country RememberedItem
        {
            get;
            set;
        }

        public ObservableCollection<Country> Countries
        {
            get;
            set;
        }

        public SampleViewModel()
        {
            Countries = new ObservableCollection<Country>();
            Country country;
            City c;
            
            Countries.Add(country = new Country());
            country.Name = "Bulgaria";
            country.Cities.Add(c = new City());
            c.Name = "Sofia";
            c.Population = 2000000;
            c.Localtion = "Latitude 44.123; Longitude 44.123";
            country.Cities.Add(c = new City());
            c.Name = "Varna";
            c.Population = 50000;
            c.Localtion = "Latitude 33.123; Longitude 33.123";
            country.Cities.Add(c = new City());
            c.Name = "Burgas";
            c.Population = 60000;
            c.Localtion = "Latitude 22.123; Longitude 22.123";

            Countries.Add(country = new Country());
            country.Name = "Serbia";
            country.Cities.Add(c = new City());
            c.Name = "Beograd";
            c.Population = 60000;
            c.Localtion = "Latitude 11.123; Longitude 11.123";
        }

        public void RememberSelectedItem(Country item)
        {
            RememberedItem = item;
        }

        public void ChangeSelectedToRemembered()
        {
            SelectedItem = RememberedItem;
            NotifyPropertyChanged("SelectedItem");
        }
    }
}
